

#define BITMAP_ID 0x4d42

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include "texture.h"

 

HDC g_HDC;
bool fullscreen = false;
bool keypressed[256];
float angle = 180.0f;


//CTexture myTexture("sky.bmp");

//CTexture myTexture2("test.bmp");


void DrawTextureCube(float xPos, float yPos, float zPos, CTexture *t1, CTexture *t2)
{

	glPushMatrix();
		
		glTranslatef(xPos, yPos, zPos);

t1->Bind();
		glBegin(GL_QUADS);	//Top face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, 0.5f, 0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, 0.5f, 0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(0.5f, 0.5f, -0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, 0.5f, -0.5f);
		glEnd();
t2->Bind();
		glBegin(GL_QUADS);	//Front face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(0.5f, -0.5f, 0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, 0.5f, 0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f, 0.5f, 0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, -0.5f, 0.5f);
		glEnd();

t1->Bind();
		glBegin(GL_QUADS);	//Right face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(0.5f, 0.5f, -0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, 0.5f, 0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(0.5f, -0.5f, 0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(0.5f, -0.5f, -0.5f);
		glEnd();
t2->Bind();
		glBegin(GL_QUADS);	//Left face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, 0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.5f, 0.5f, 0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f, 0.5f, -0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
		glEnd();
t1->Bind();
		glBegin(GL_QUADS);	//Bottomface
			glTexCoord2f(0.0f, 0.0f); glVertex3f(0.5f, -0.5f, 0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.5f, -0.5f, 0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(0.5f, -0.5f, -0.5f);
		glEnd();
t2->Bind();
		glBegin(GL_QUADS);	//Back face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(0.5f, 0.5f, -0.5f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, -0.5f, -0.5f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, 0.5f, -0.5f);
		glEnd();


	glPopMatrix();


}



void Render(CTexture *t1, CTexture *t2)
{


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glTranslatef(0.0f, 0.0f, -3.0f);
	glRotatef(angle, 1.0f, 0.0f, 0.0f);
	glRotatef(angle, 0.0f, 1.0f, 0.0f);


	DrawTextureCube(0.0f, 0.0f, 0.0f, t1, t2);

	if(angle >= 360.0f)
	{

		angle = 0.0f;

	}

	angle += .5f;

	glFlush();
	SwapBuffers(g_HDC);

}




void SetupPixelFormat(HDC hDC)
{
 	int nPixelFormat;

	static PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		32,
		0,0,0,0,0,0,
		0,
		0,
		0,
		0,0,0,0,
		16,
		0,
		0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};

	nPixelFormat=ChoosePixelFormat(hDC, &pfd);

	SetPixelFormat(hDC, nPixelFormat, &pfd);


}


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	static HGLRC hRC;
	static HDC hDC;
	int width, height;

	switch(message)
	{

	case WM_CREATE:

		hDC = GetDC(hwnd);
		g_HDC = hDC;
		SetupPixelFormat(hDC);

		hRC = wglCreateContext(hDC);
		wglMakeCurrent(hDC, hRC);

		return 0;
		break;

	case WM_CLOSE:

		wglMakeCurrent(hDC, NULL);
		wglDeleteContext(hRC);

		PostQuitMessage(0);

		return 0;
		break;

	case WM_SIZE:

		height = HIWORD(lParam);
		width  = LOWORD(lParam);

		if(height==0)
		{
			height=1;
		}


		glViewport(0, 0, width, height);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();

		gluPerspective(54.0f, (GLfloat)width/(GLfloat)height, 1.0f, 1000.0f);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		return 0;
		break;

	default:
		break;

	}


	return (DefWindowProc(hwnd, message, wParam, lParam));

}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{

	WNDCLASSEX	windowClass;
	HWND		hwnd;
	MSG			msg;
	bool		done;

	DWORD 		dwExStyle;
	DWORD		dwStyle;
	RECT		windowRect;



	int width	= 1280;
	int height	= 1024;
	int bits	= 32;


	windowRect.left	= (long)0;
	windowRect.right= (long)width;
	windowRect.top	= (long)0;
	windowRect.bottom=(long)height;


	windowClass.cbSize			= sizeof(WNDCLASSEX);
	windowClass.style			= CS_HREDRAW | CS_VREDRAW;
	windowClass.lpfnWndProc		= WndProc;
	windowClass.cbClsExtra		= 0;
	windowClass.cbWndExtra		= 0;
	windowClass.hInstance		= hInstance;
	windowClass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	windowClass.hCursor			= LoadCursor(NULL, IDC_ARROW);
	windowClass.hbrBackground	= NULL;
	windowClass.lpszMenuName	= NULL;
	windowClass.lpszClassName	= "MyClass";
	windowClass.hIconSm			= LoadIcon(NULL, IDI_WINLOGO);


	if(!RegisterClassEx(&windowClass))
		return 0;


	if(fullscreen)
	{
		DEVMODE dmScreenSettings;

		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));
		dmScreenSettings.dmSize = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth = width;
		dmScreenSettings.dmPelsHeight = height;
		dmScreenSettings.dmBitsPerPel = bits;
		dmScreenSettings.dmFields =		DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

				
		if(ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
		{
			
			MessageBox(NULL, "Display mode failed", NULL, MB_OK);
			fullscreen = FALSE;

		}

	}

	if(fullscreen)
	{
		
		dwExStyle = WS_EX_APPWINDOW;
		dwStyle = WS_POPUP;
		ShowCursor(TRUE);

	}
	else
	{

	   dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
	   dwStyle = WS_OVERLAPPEDWINDOW;

	}


	AdjustWindowRectEx(&windowRect, dwStyle, FALSE, dwExStyle);

	hwnd = CreateWindowEx(	NULL, 
							"MyClass",
							"MyApp",
							dwStyle | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
							0, 0,
							windowRect.right - windowRect.left, windowRect.bottom - windowRect.top, 
							NULL,
							NULL,
							hInstance,
							NULL
						);


	if(!hwnd)
		return 0;

	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);

	done = false;


	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);			//Clear background to black
	glShadeModel(GL_SMOOTH);						//Use smooth shading
	glEnable(GL_DEPTH_TEST);						//Use hidden surface removal
	glEnable(GL_CULL_FACE);							//Do not calculate inside of polys
	glFrontFace(GL_CCW);							//Counterclockwise polygons are out
	glEnable(GL_TEXTURE_2D);						//Enable 2D texturing


CTexture myTexture("water.bmp");

CTexture myTexture2("Terrain.bmp");
 

	while(!done)
	{

		PeekMessage(&msg, hwnd, NULL, NULL, PM_REMOVE);

		if(msg.message == WM_QUIT)
		{
			done = true;
		}
		else
		{

			//myTexture.Bind();

		//	myTexture.ViewBMP();
			Render(&myTexture, &myTexture2);
			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}
	}

	if(fullscreen)
	{

		ChangeDisplaySettings(NULL, 0);
		ShowCursor(TRUE);

	}

	return msg.wParam;



}

